/*
Original copyright follows:

------------------------------------------------------------------------
Hewlett-Packard Sample Code
(c) Copyright Hewlett-Packard 1996. All rights are reserved.  Copying or
other reproduction of this program except for archival purposes is
prohibited without the prior written consent of Hewlett-Packard Company.
RESTRICTED RIGHTS LEGEND
Use, duplication, or disclosure by the U.S. Government is subject to
restrictions as set forth in subdivision (c) (1) (ii) of the Rights in
Technical Data and Computer Software clause at 252.227-7013.
HEWLETT-PACKARD COMPANY, Palo Alto, California
------------------------------------------------------------------------
*/

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/extensions/shape.h>


char msg[300];
int yo=0;


void shapeResize(dpy, shapeWin) 
    Display *dpy;
    Window   shapeWin;
{
    Pixmap pixmap;
    GC gc, maskgc;

    //  Create mask pixmap:
    pixmap = XCreatePixmap(dpy,shapeWin,300,300,1);
    maskgc = XCreateGC (dpy, pixmap,0,0);

gc = XCreateGC (dpy, shapeWin,0,0);

//  Clear the window:
XSetForeground(dpy,gc,WhitePixel(dpy,DefaultScreen(dpy)));
XFillRectangle(dpy,shapeWin,gc, 0,0, 300,300);

//  Clear the mask pixmap:
XSetForeground(dpy,maskgc,BlackPixel(dpy,DefaultScreen(dpy)));
XFillRectangle(dpy,pixmap,maskgc, 0,0, 300,300);

XSetForeground(dpy,gc,BlackPixel(dpy,DefaultScreen(dpy)));
XSetForeground(dpy,maskgc,WhitePixel(dpy,DefaultScreen(dpy)));

//  Type some text into the gc's:
sprintf (msg, "shapeResize(): yo = %i", yo++);
XDrawString(dpy,pixmap,maskgc,10,50,msg,strlen(msg));
//XDrawString(dpy,pixmap,maskgc,11,50,msg,strlen(msg));
//XDrawString(dpy,pixmap,maskgc,10,51,msg,strlen(msg));
//XDrawString(dpy,pixmap,maskgc,11,51,msg,strlen(msg));

XFreeGC(dpy,gc);

    XShapeCombineMask(dpy, shapeWin, ShapeBounding, 0, 0, pixmap, ShapeSet);
    XFreeGC(dpy,maskgc);

//    XShapeCombineRectangles(dpy, shapeWin, ShapeBounding, 0, 0, 
//		            rects, nRectangles, ShapeSet, Unsorted);

  XFlush(dpy);
}

void main(argc, argv)
    int    argc; 
    char **argv;
{
    Display             *dpy;
    Window               shapeWin;
    XSetWindowAttributes shapeAttr;
    long                 shapeAttrMask;

    XEvent               event;

    dpy = XOpenDisplay( (char *)getenv("DISPLAY"));

    shapeAttr.background_pixel = WhitePixel(dpy, DefaultScreen(dpy));
    shapeAttrMask = CWBackPixel;

    shapeWin = XCreateWindow(dpy, RootWindow(dpy, DefaultScreen(dpy)),
			     100, 100, 300, 300, 0, 
			     CopyFromParent, CopyFromParent, CopyFromParent,
			     shapeAttrMask, &shapeAttr);

    XStoreName (dpy, shapeWin, "Yo-shape");

    shapeResize(dpy, shapeWin);

    XSelectInput(dpy, shapeWin, ExposureMask | KeyPressMask |
                        ButtonPressMask | StructureNotifyMask);
    XMapWindow(dpy, shapeWin);

    while(1){
	XNextEvent( dpy, &event );
	if( event.type == ConfigureNotify ){
  	    shapeResize(dpy, shapeWin);
	}
    }
}
